   '***********************************************************************
   ' LED SnowFlake by PaJa
   '   (LED matrix 8x8)
   ' v 1.0 (z 6.11.2011)
   '
   ' Autor : Pavel Jank
   ' www.paja-trb.unas.cz
   ' paja-trb@seznam.cz
   '
   '***********************************************************************

$regfile = "m8def.dat"
$crystal = 8000000

Config Portd = Output
Config Portb.0 = Output
Config Portb.1 = Output
Config Portb.2 = Output
Config Portc.2 = Input                                      '  s1
Config Portc.3 = Input                                      '  s2
Config Portc.4 = Input                                      '  s3
Config Portc.5 = Input                                      '  s4
S1 Alias Pinc.2                                             'Speed +
S2 Alias Pinc.3                                             'Speed -
S3 Alias Pinc.5                                             'Effect -
S4 Alias Pinc.4                                             'Effect +

Dim Data_out As Byte                                        'Data to Port
Dim D As Byte : D = 0                                       'poradi znaku z tabulky
Dim D_max As Byte : D_max = 0                               'pocet znaku v tabulce konkretniho efektu
Dim Efekty As Byte : Efekty = 1                             'cislo efektu / prednastaveni efektu po zapnuti
Dim Efekty_max As Byte : Efekty_max = 12                    'celkovy pocet efektu (pro snazsi pridavani novych)
Dim Efekt_stop As Bit : Efekt_stop = 0                      'pri Efekt_stop=1 se zastavi zmena efekti (az do stisku nektereho tlac. Effect)
Dim Opak As Byte : Opak = 1                                 'pocet opakovani efektu
Dim S As Byte : S = 5                                       'rychlost/pocet opakovani waitms 8 - poradi z tabulky / prednastaveni rychlosti po zapnuti
Dim Speed_run As Bit : Speed_run = 0                        'pri Speed_run=1 je aktivni plynula zmena rychlosti
Dim Spedtek As Byte                                         ' "rychlost" vyctena z tabulky Speed
Spedtek = Lookup(s , Tab_speed)                             'podivej se do tabulky Speed a vycti "rychlost"

'===============================================================================

Do
'convert BDC to DEC - 74LS145                               'out LED in log. 0
Portb = &B00000000                                          '0
Gosub Outdata
Portb = &B00000001                                          '1
Gosub Outdata
Portb = &B00000010                                          '2
Gosub Outdata
Portb = &B00000011                                          '3
Gosub Outdata
Portb = &B00000100                                          '4
Gosub Outdata
Portb = &B00000101                                          '5
Gosub Outdata
Portb = &B00000110                                          '6
Gosub Outdata
Portb = &B00000111                                          '7
Gosub Outdata

If Speed_run = 1 Then
   S = S + 1
   If S > 38 Then S = 1
   Spedtek = Lookup(s , Tab_speed2)
Else
   Spedtek = Lookup(s , Tab_speed)
End If

Do
   Waitms 8
   Decr Spedtek
   Debounce S1 , 0 , Plus_speed , Sub
   Debounce S2 , 0 , Minus_speed , Sub
   Debounce S4 , 0 , Plus_effect , Sub
   Debounce S3 , 0 , Minus_effect , Sub
   If S3 = 0 And S4 = 0 Then Efekt_stop = 1                 'soucasny stisk tlac. S3+S4 (Effect + a -) ma za nasledek zastaveni zmen efektu
   If S1 = 0 And S2 = 0 Then Speed_run = 1                  'soucasny stisk tlac. S1+S2 (Speed + a -) ma za nasledek opakovane zrychlovani a zpomalovani rychlosti
Loop Until Spedtek < 1

If D > D_max Then
   D = 0
   Incr Opak
End If

If Efekt_stop = 1 Then Opak = 0
If Opak > 8 Then
   Opak = 0
   Incr Efekty
End If

If Efekty > Efekty_max Then
   Efekty = 1
   D = 0
End If

Loop

End

'===============================================================================
'
Outdata:
  Select Case Efekty
    Case 1 : Data_out = Lookup(d , Tab_efect_01)            'kdyz  Efekty=1 tak se podivej do tabulky efektu 01
             D_max = 63                                     'pocet dat v tabulce tohoto efektu je 63 (0 az 63)
    Case 2 : Data_out = Lookup(d , Tab_efect_02)
              D_max = 63
    Case 3 : Data_out = Lookup(d , Tab_efect_03)
             D_max = 127
    Case 4 : Data_out = Lookup(d , Tab_efect_04)
             D_max = 127
    Case 5 : Data_out = Lookup(d , Tab_efect_05)
             D_max = 63
    Case 6 : Data_out = Lookup(d , Tab_efect_06)
             D_max = 63
    Case 7 : Data_out = Lookup(d , Tab_efect_07)
             D_max = 63
    Case 8 : Data_out = Lookup(d , Tab_efect_08)
             D_max = 127
    Case 9 : Data_out = Lookup(d , Tab_efect_09)
             D_max = 127
    Case 10 : Data_out = Lookup(d , Tab_efect_10)
              D_max = 63
    Case 11 : Data_out = Lookup(d , Tab_efect_11)
              D_max = 143
    Case 12 : Data_out = Lookup(d , Tab_efect_12)
              D_max = 127
  End Select
  Portd = Data_out                                          'posli data nactena z Efectu na portD
  Incr D                                                    'Zvys D (prechod na dalsi pozici tabulky
  Waitms 2                                                  'pockej (nech rozsvicenou LED) 2ms
  Portd = &H00                                              'vynuluj portD
Return
'
Plus_speed:
   Incr S
   If S > 9 Then S = 9
   Spedtek = Lookup(s , Tab_speed)
   Speed_run = 0
Return
'
Minus_speed:
   Decr S
   If S < 1 Then S = 1
   Spedtek = Lookup(s , Tab_speed)
   Speed_run = 0
Return
'
Plus_effect:
   Incr Efekty                                              'Zvys Efekty
   If Efekty > Efekty_max Then Efekty = 1                   'zkontroluj aby hodnota neprekrocila pocet efekt - jinak ji usmerni
   Opak = 0                                                 'vynuluj opakovani efektu
   D = 0
   Efekt_stop = 0                                           'zacni efekt od zacatku
Return
'
Minus_effect:
   Decr Efekty
   If Efekty < 1 Then Efekty = Efekty_max
   Opak = 0
   D = 0
   Efekt_stop = 0
Return

'===============================================================================

Tab_speed:                                                  'normalni rychlost nastav. tlacitky
Data 0 , 1 , 2 , 3 , 4 , 6 , 8 , 10 , 13 , 16 , 13 , 10 , 8 , 6 , 4 , 3 , 2 , 1

Tab_speed2:                                                 'automaticka zmena rychlosti (aktivovana dvojstiskem)
Data 0 , 1 , 2 , 2 , 3 , 3 , 3 , 4 , 4 , 4 , 5 , 5 , 6 , 6 , 7 , 7 , 8 , 9 , 10 , 11 , 12 , 11 , 10 , 9 , 8 , 7 , 7 , 6 , 6 , 5 , 5 , 4 , 4 , 4 , 3 , 3 , 3 , 2 , 2 , 1

'-------------------------------------------------------------------------------

Tab_efect_01:                                               'rotace doprava
Data &HFF , &H00 , &H00 , &H00 , &HFF , &H00 , &H00 , &H00
Data &H00 , &HFF , &H00 , &H00 , &H00 , &HFF , &H00 , &H00
Data &H00 , &H00 , &HFF , &H00 , &H00 , &H00 , &HFF , &H00
Data &H00 , &H00 , &H00 , &HFF , &H00 , &H00 , &H00 , &HFF
Data &HFF , &H00 , &H00 , &H00 , &HFF , &H00 , &H00 , &H00
Data &H00 , &HFF , &H00 , &H00 , &H00 , &HFF , &H00 , &H00
Data &H00 , &H00 , &HFF , &H00 , &H00 , &H00 , &HFF , &H00
Data &H00 , &H00 , &H00 , &HFF , &H00 , &H00 , &H00 , &HFF

Tab_efect_02:                                               'rotace doleva
Data &H00 , &H00 , &H00 , &HFF , &H00 , &H00 , &H00 , &HFF
Data &H00 , &H00 , &HFF , &H00 , &H00 , &H00 , &HFF , &H00
Data &H00 , &HFF , &H00 , &H00 , &H00 , &HFF , &H00 , &H00
Data &HFF , &H00 , &H00 , &H00 , &HFF , &H00 , &H00 , &H00
Data &H00 , &H00 , &H00 , &HFF , &H00 , &H00 , &H00 , &HFF
Data &H00 , &H00 , &HFF , &H00 , &H00 , &H00 , &HFF , &H00
Data &H00 , &HFF , &H00 , &H00 , &H00 , &HFF , &H00 , &H00
Data &HFF , &H00 , &H00 , &H00 , &HFF , &H00 , &H00 , &H00

Tab_efect_03:
Data &H80 , &H80 , &H80 , &H80 , &H80 , &H80 , &H80 , &H80  'stred
Data &H40 , &H40 , &H40 , &H40 , &H40 , &H40 , &H40 , &H40
Data &H20 , &H20 , &H20 , &H20 , &H20 , &H20 , &H20 , &H20
Data &H10 , &H10 , &H10 , &H10 , &H10 , &H10 , &H10 , &H10
Data &H08 , &H08 , &H08 , &H08 , &H08 , &H08 , &H08 , &H08
Data &H04 , &H04 , &H04 , &H04 , &H04 , &H04 , &H04 , &H04
Data &H02 , &H02 , &H02 , &H02 , &H02 , &H02 , &H02 , &H02
Data &H01 , &H01 , &H01 , &H01 , &H01 , &H01 , &H01 , &H01  'kraj
Data &H01 , &H01 , &H01 , &H01 , &H01 , &H01 , &H01 , &H01  'kraj
Data &H02 , &H02 , &H02 , &H02 , &H02 , &H02 , &H02 , &H02
Data &H04 , &H04 , &H04 , &H04 , &H04 , &H04 , &H04 , &H04
Data &H08 , &H08 , &H08 , &H08 , &H08 , &H08 , &H08 , &H08
Data &H10 , &H10 , &H10 , &H10 , &H10 , &H10 , &H10 , &H10
Data &H20 , &H20 , &H20 , &H20 , &H20 , &H20 , &H20 , &H20
Data &H40 , &H40 , &H40 , &H40 , &H40 , &H40 , &H40 , &H40
Data &H80 , &H80 , &H80 , &H80 , &H80 , &H80 , &H80 , &H80  'stred

Tab_efect_04:                                               'PaJa - rozsvit ze stredu ven a zpatky zhasni
Data &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00
Data &H80 , &H80 , &H80 , &H80 , &H80 , &H80 , &H80 , &H80
Data &HC0 , &HC0 , &HC0 , &HC0 , &HC0 , &HC0 , &HC0 , &HC0
Data &HE0 , &HE0 , &HE0 , &HE0 , &HE0 , &HE0 , &HE0 , &HE0
Data &HF0 , &HF0 , &HF0 , &HF0 , &HF0 , &HF0 , &HF0 , &HF0
Data &HF8 , &HF8 , &HF8 , &HF8 , &HF8 , &HF8 , &HF8 , &HF8
Data &HFC , &HFC , &HFC , &HFC , &HFC , &HFC , &HFC , &HFC
Data &HFE , &HFE , &HFE , &HFE , &HFE , &HFE , &HFE , &HFE
Data &HFF , &HFF , &HFF , &HFF , &HFF , &HFF , &HFF , &HFF
Data &HFE , &HFE , &HFE , &HFE , &HFE , &HFE , &HFE , &HFE
Data &HFC , &HFC , &HFC , &HFC , &HFC , &HFC , &HFC , &HFC
Data &HF8 , &HF8 , &HF8 , &HF8 , &HF8 , &HF8 , &HF8 , &HF8
Data &HF0 , &HF0 , &HF0 , &HF0 , &HF0 , &HF0 , &HF0 , &HF0
Data &HE0 , &HE0 , &HE0 , &HE0 , &HE0 , &HE0 , &HE0 , &HE0
Data &HC0 , &HC0 , &HC0 , &HC0 , &HC0 , &HC0 , &HC0 , &HC0
Data &H80 , &H80 , &H80 , &H80 , &H80 , &H80 , &H80 , &H80

Tab_efect_05:                                               'vr doprava
Data &H01 , &H02 , &H04 , &H08 , &H10 , &H20 , &H40 , &H80
Data &H80 , &H01 , &H02 , &H04 , &H08 , &H10 , &H20 , &H40
Data &H40 , &H80 , &H01 , &H02 , &H04 , &H08 , &H10 , &H20
Data &H20 , &H40 , &H80 , &H01 , &H02 , &H04 , &H08 , &H10
Data &H10 , &H20 , &H40 , &H80 , &H01 , &H02 , &H04 , &H08
Data &H08 , &H10 , &H20 , &H40 , &H80 , &H01 , &H02 , &H04
Data &H04 , &H08 , &H10 , &H20 , &H40 , &H80 , &H01 , &H02
Data &H02 , &H04 , &H08 , &H10 , &H20 , &H40 , &H80 , &H01

Tab_efect_06:                                               'vr doleva
Data &H80 , &H40 , &H20 , &H10 , &H08 , &H04 , &H02 , &H01
Data &H40 , &H20 , &H10 , &H08 , &H04 , &H02 , &H01 , &H80
Data &H20 , &H10 , &H08 , &H04 , &H02 , &H01 , &H80 , &H40
Data &H10 , &H08 , &H04 , &H02 , &H01 , &H80 , &H40 , &H20
Data &H08 , &H04 , &H02 , &H01 , &H80 , &H40 , &H20 , &H10
Data &H04 , &H02 , &H01 , &H80 , &H40 , &H20 , &H10 , &H08
Data &H02 , &H01 , &H80 , &H40 , &H20 , &H10 , &H08 , &H04
Data &H01 , &H80 , &H40 , &H20 , &H10 , &H08 , &H04 , &H02

Tab_efect_07:                                               'PaJa - doprava rotujc Y (vrtule)
Data &HFF , &H00 , &HFF , &H00 , &H00 , &HFF , &H00 , &H00
Data &H00 , &HFF , &H00 , &HFF , &H00 , &H00 , &HFF , &H00
Data &H00 , &H00 , &HFF , &H00 , &HFF , &H00 , &H00 , &HFF
Data &HFF , &H00 , &H00 , &HFF , &H00 , &HFF , &H00 , &H00
Data &H00 , &HFF , &H00 , &H00 , &HFF , &H00 , &HFF , &H00
Data &H00 , &H00 , &HFF , &H00 , &H00 , &HFF , &H00 , &HFF
Data &HFF , &H00 , &H00 , &HFF , &H00 , &H00 , &HFF , &H00
Data &H00 , &HFF , &H00 , &H00 , &HFF , &H00 , &H00 , &HFF

Tab_efect_08:
Data &H01 , &H01 , &H01 , &H01 , &H01 , &H01 , &H01 , &H01  'rozsveceni do stredu
Data &H03 , &H03 , &H03 , &H03 , &H03 , &H03 , &H03 , &H03
Data &H07 , &H07 , &H07 , &H07 , &H07 , &H07 , &H07 , &H07
Data &H0F , &H0F , &H0F , &H0F , &H0F , &H0F , &H0F , &H0F
Data &H1F , &H1F , &H1F , &H1F , &H1F , &H1F , &H1F , &H1F
Data &H3F , &H3F , &H3F , &H3F , &H3F , &H3F , &H3F , &H3F
Data &H7F , &H7F , &H7F , &H7F , &H7F , &H7F , &H7F , &H7F
Data &HFF , &HFF , &HFF , &HFF , &HFF , &HFF , &HFF , &HFF
Data &HFF , &HFF , &HFF , &HFF , &HFF , &HFF , &HFF , &HFF  'zhasinani ze stredu ven
Data &H7F , &H7F , &H7F , &H7F , &H7F , &H7F , &H7F , &H7F
Data &H3F , &H3F , &H3F , &H3F , &H3F , &H3F , &H3F , &H3F
Data &H1F , &H1F , &H1F , &H1F , &H1F , &H1F , &H1F , &H1F
Data &H0F , &H0F , &H0F , &H0F , &H0F , &H0F , &H0F , &H0F
Data &H07 , &H07 , &H07 , &H07 , &H07 , &H07 , &H07 , &H07
Data &H03 , &H03 , &H03 , &H03 , &H03 , &H03 , &H03 , &H03
Data &H01 , &H01 , &H01 , &H01 , &H01 , &H01 , &H01 , &H01

Tab_efect_09:                                               'tecky dovnitr -> ven
Data &H01 , &H80 , &H01 , &H80 , &H01 , &H80 , &H01 , &H80
Data &H02 , &H40 , &H02 , &H40 , &H02 , &H40 , &H02 , &H40
Data &H04 , &H20 , &H04 , &H20 , &H04 , &H20 , &H04 , &H20
Data &H08 , &H10 , &H08 , &H10 , &H08 , &H10 , &H08 , &H10
Data &H10 , &H08 , &H10 , &H08 , &H10 , &H08 , &H10 , &H08
Data &H20 , &H04 , &H20 , &H04 , &H20 , &H04 , &H20 , &H04
Data &H40 , &H02 , &H40 , &H02 , &H40 , &H02 , &H40 , &H02
Data &H80 , &H01 , &H80 , &H01 , &H80 , &H01 , &H80 , &H01  '
Data &H80 , &H01 , &H80 , &H01 , &H80 , &H01 , &H80 , &H01
Data &H40 , &H02 , &H40 , &H02 , &H40 , &H02 , &H40 , &H02
Data &H20 , &H04 , &H20 , &H04 , &H20 , &H04 , &H20 , &H04
Data &H10 , &H08 , &H10 , &H08 , &H10 , &H08 , &H10 , &H08
Data &H08 , &H10 , &H08 , &H10 , &H08 , &H10 , &H08 , &H10
Data &H04 , &H20 , &H04 , &H20 , &H04 , &H20 , &H04 , &H20
Data &H02 , &H40 , &H02 , &H40 , &H02 , &H40 , &H02 , &H40
Data &H01 , &H80 , &H01 , &H80 , &H01 , &H80 , &H01 , &H80

Tab_efect_10:                                               ' "smile"
Data &H01 , &H01 , &H01 , &H01 , &H80 , &H80 , &H80 , &H80
Data &H02 , &H02 , &H02 , &H02 , &H40 , &H40 , &H40 , &H40
Data &H04 , &H04 , &H04 , &H04 , &H20 , &H20 , &H20 , &H20
Data &H08 , &H08 , &H08 , &H08 , &H10 , &H10 , &H10 , &H10
Data &H10 , &H10 , &H10 , &H10 , &H08 , &H08 , &H08 , &H08
Data &H20 , &H20 , &H20 , &H20 , &H04 , &H04 , &H04 , &H04
Data &H40 , &H40 , &H40 , &H40 , &H02 , &H02 , &H02 , &H02
Data &H80 , &H80 , &H80 , &H80 , &H01 , &H01 , &H01 , &H01

Tab_efect_11:                                               'rotace - "load"
Data &H00 , &H00 , &HFF , &H00 , &H00 , &H00 , &H00 , &H00
Data &H00 , &H00 , &HFF , &HFF , &H00 , &H00 , &H00 , &H00
Data &H00 , &H00 , &HFF , &HFF , &HFF , &H00 , &H00 , &H00
Data &H00 , &H00 , &HFF , &HFF , &HFF , &HFF , &H00 , &H00
Data &H00 , &H00 , &HFF , &HFF , &HFF , &HFF , &HFF , &H00
Data &H00 , &H00 , &HFF , &HFF , &HFF , &HFF , &HFF , &HFF
Data &HFF , &H00 , &HFF , &HFF , &HFF , &HFF , &HFF , &HFF
Data &HFF , &HFF , &HFF , &HFF , &HFF , &HFF , &HFF , &HFF
Data &HFF , &HFF , &HFF , &HFF , &HFF , &HFF , &HFF , &HFF
Data &HFF , &HFF , &HFF , &HFF , &HFF , &HFF , &HFF , &HFF
Data &HFF , &HFF , &H00 , &HFF , &HFF , &HFF , &HFF , &HFF
Data &HFF , &HFF , &H00 , &H00 , &HFF , &HFF , &HFF , &HFF
Data &HFF , &HFF , &H00 , &H00 , &H00 , &HFF , &HFF , &HFF
Data &HFF , &HFF , &H00 , &H00 , &H00 , &H00 , &HFF , &HFF
Data &HFF , &HFF , &H00 , &H00 , &H00 , &H00 , &H00 , &HFF
Data &HFF , &HFF , &H00 , &H00 , &H00 , &H00 , &H00 , &H00
Data &H00 , &HFF , &H00 , &H00 , &H00 , &H00 , &H00 , &H00
Data &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00

Tab_efect_12:                                               'paprsky
Data &H80 , &H00 , &H80 , &H00 , &H80 , &H00 , &H80 , &H00
Data &HC0 , &H00 , &HC0 , &H00 , &HC0 , &H00 , &HC0 , &H00
Data &HE0 , &H80 , &HE0 , &H80 , &HE0 , &H80 , &HE0 , &H80
Data &HF0 , &HC0 , &HF0 , &HC0 , &HF0 , &HC0 , &HF0 , &HC0
Data &HF8 , &HE0 , &HF8 , &HE0 , &HF8 , &HE0 , &HF8 , &HE0
Data &HFC , &HF0 , &HFC , &HF0 , &HFC , &HF0 , &HFC , &HF0
Data &HFE , &HF8 , &HFE , &HF8 , &HFE , &HF8 , &HFE , &HF8
Data &HFF , &HFC , &HFF , &HFC , &HFF , &HFC , &HFF , &HFC
Data &HFE , &HFE , &HFE , &HFE , &HFE , &HFE , &HFE , &HFE
Data &HFC , &HFF , &HFC , &HFF , &HFC , &HFF , &HFC , &HFF
Data &HF8 , &HFE , &HF8 , &HFE , &HF8 , &HFE , &HF8 , &HFE
Data &HF0 , &HFC , &HF0 , &HFC , &HF0 , &HFC , &HF0 , &HFC
Data &HE0 , &HF8 , &HE0 , &HF8 , &HE0 , &HF8 , &HE0 , &HF8
Data &HC0 , &HF0 , &HC0 , &HF0 , &HC0 , &HF0 , &HC0 , &HF0
Data &H80 , &HE0 , &H80 , &HE0 , &H80 , &HE0 , &H80 , &HE0
Data &H00 , &HC0 , &H00 , &HC0 , &H00 , &HC0 , &H00 , &HC0